Index: /trunk/src/calcpv_nests.f90
===================================================================
--- /trunk/src/calcpv_nests.f90	(revision 30)
+++ /trunk/src/calcpv_nests.f90	(revision 20)
@@ -21,5 +21,5 @@
 
 subroutine calcpv_nests(l,n,uuhn,vvhn,pvhn)
-  !                     i i  i    i    o
+  !                        i i  i    i    o
   !*****************************************************************************
   !                                                                            *
@@ -48,6 +48,6 @@
   integer :: nlck,l
   real :: vx(2),uy(2),phi,tanphi,cosphi,dvdx,dudy,f
-  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt
-  real :: ppml(0:nxmaxn-1,0:nymaxn-1,nuvzmax),ppmk(0:nxmaxn-1,0:nymaxn-1,nuvzmax)
+  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt,ppmk
+  real :: ppml(nuvzmax)
   real :: thup,thdn
   real,parameter :: eps=1.e-5,p0=101325
@@ -61,13 +61,4 @@
   ! Loop over entire grid
   !**********************
-  do kl=1,nuvz
-    do jy=0,nyn(l)-1
-      do ix=0,nxn(l)-1
-         ppml(ix,jy,kl)=akz(kl)+bkz(kl)*psn(ix,jy,1,n,l)
-      enddo
-    enddo
-  enddo
-  ppmk=(100000./ppml)**kappa
-
   do jy=0,nyn(l)-1
     phi = (ylat0n(l) + jy * dyn(l)) * pi / 180.
@@ -97,4 +88,8 @@
       if (ix.eq.0.or.ix.eq.nxn(l)-1) jumpx=1
       jux=jumpx
+  ! Precalculate pressure values for efficiency
+      do kl=1,nuvz
+        ppml(kl)=akz(kl)+bkz(kl)*psn(ix,jy,1,n,l)
+      end do
   !
   ! Loop over the vertical
@@ -102,5 +97,6 @@
 
       do kl=1,nuvz
-        theta=tthn(ix,jy,kl,n,l)*ppmk(ix,jy,kl)
+        ppmk=akz(kl)+bkz(kl)*psn(ix,jy,1,n,l)
+        theta=tthn(ix,jy,kl,n,l)*(100000./ppmk)**kappa
         klvrp=kl+1
         klvrm=kl-1
@@ -111,7 +107,9 @@
         if (klvrp.gt.nuvz) klvrp=nuvz
         if (klvrm.lt.1) klvrm=1
-        thetap=tthn(ix,jy,klvrp,n,l)*ppmk(ix,jy,klvrp)
-        thetam=tthn(ix,jy,klvrm,n,l)*ppmk(ix,jy,klvrm)
-        dthetadp=(thetap-thetam)/(ppml(ix,jy,klvrp)-ppml(ix,jy,klvrm))
+        ppmk=akz(klvrp)+bkz(klvrp)*psn(ix,jy,1,n,l)
+        thetap=tthn(ix,jy,klvrp,n,l)*(100000./ppmk)**kappa
+        ppmk=akz(klvrm)+bkz(klvrm)*psn(ix,jy,1,n,l)
+        thetam=tthn(ix,jy,klvrm,n,l)*(100000./ppmk)**kappa
+        dthetadp=(thetap-thetam)/(ppml(klvrp)-ppml(klvrm))
 
   ! Compute vertical position at pot. temperature surface on subgrid
@@ -136,6 +134,8 @@
           kch=kch+1
           k=kup
-          thdn=tthn(ivr,jy,k,n,l)*ppmk(ivr,jy,k)
-          thup=tthn(ivr,jy,k+1,n,l)*ppmk(ivr,jy,k+1)
+          ppmk=akz(k)+bkz(k)*psn(ivr,jy,1,n,l)
+          thdn=tthn(ivr,jy,k,n,l)*(100000./ppmk)**kappa
+          ppmk=akz(k+1)+bkz(k+1)*psn(ivr,jy,1,n,l)
+          thup=tthn(ivr,jy,k+1,n,l)*(100000./ppmk)**kappa
 
       if (((thdn.ge.theta).and.(thup.le.theta)).or. &
@@ -158,6 +158,8 @@
           kch=kch+1
           k=kdn
-          thdn=tthn(ivr,jy,k,n,l)*ppmk(ivr,jy,k)
-          thup=tthn(ivr,jy,k+1,n,l)*ppmk(ivr,jy,k+1)
+          ppmk=akz(k)+bkz(k)*psn(ivr,jy,1,n,l)
+          thdn=tthn(ivr,jy,k,n,l)*(100000./ppmk)**kappa
+          ppmk=akz(k+1)+bkz(k+1)*psn(ivr,jy,1,n,l)
+          thup=tthn(ivr,jy,k+1,n,l)*(100000./ppmk)**kappa
       if (((thdn.ge.theta).and.(thup.le.theta)).or. &
            ((thdn.le.theta).and.(thup.ge.theta))) then
@@ -210,6 +212,8 @@
           kch=kch+1
           k=kup
-          thdn=tthn(ix,j,k,n,l)*ppmk(ix,j,k)
-          thup=tthn(ix,j,k+1,n,l)*ppmk(ix,j,k+1)
+          ppmk=akz(k)+bkz(k)*psn(ix,j,1,n,l)
+          thdn=tthn(ix,j,k,n,l)*(100000./ppmk)**kappa
+          ppmk=akz(k+1)+bkz(k+1)*psn(ix,j,1,n,l)
+          thup=tthn(ix,j,k+1,n,l)*(100000./ppmk)**kappa
       if (((thdn.ge.theta).and.(thup.le.theta)).or. &
            ((thdn.le.theta).and.(thup.ge.theta))) then
@@ -231,6 +235,8 @@
           kch=kch+1
           k=kdn
-          thdn=tthn(ix,j,k,n,l)*ppmk(ix,j,k)
-          thup=tthn(ix,j,k+1,n,l)*ppmk(ix,j,k+1)
+          ppmk=akz(k)+bkz(k)*psn(ix,j,1,n,l)
+          thdn=tthn(ix,j,k,n,l)*(100000./ppmk)**kappa
+          ppmk=akz(k+1)+bkz(k+1)*psn(ix,j,1,n,l)
+          thup=tthn(ix,j,k+1,n,l)*(100000./ppmk)**kappa
       if (((thdn.ge.theta).and.(thup.le.theta)).or. &
            ((thdn.le.theta).and.(thup.ge.theta))) then
Index: /trunk/src/com_mod.f90
===================================================================
--- /trunk/src/com_mod.f90	(revision 30)
+++ /trunk/src/com_mod.f90	(revision 20)
@@ -113,6 +113,4 @@
   ! lagespectra  1 if age spectra calculation switched on, 2 if not
 
-  integer :: lnetcdfout
-  ! lnetcdfout   1 for netcdf grid output, 0 if not. Set in COMMAND (namelist input)
 
   integer :: nageclass,lage(maxageclass)
@@ -342,6 +340,9 @@
   real :: qvh(0:nxmax-1,0:nymax-1,nuvzmax,2)
   real :: pplev(0:nxmax-1,0:nymax-1,nuvzmax,2)
+  !scavenging NIK, PS
   integer(kind=1) :: clouds(0:nxmax-1,0:nymax-1,nzmax,2)
   integer :: cloudsh(0:nxmax-1,0:nymax-1,2)
+      integer icloudbot(0:nxmax-1,0:nymax-1,2)
+      integer icloudthck(0:nxmax-1,0:nymax-1,2)
 
 
@@ -358,4 +359,7 @@
   !      rainout  conv/lsp dominated  2/3
   !      washout  conv/lsp dominated  4/5
+! PS 2013
+!c icloudbot (m)        cloud bottom height
+!c icloudthck (m)       cloud thickness     
 
   ! pplev for the GFS version
@@ -684,11 +688,9 @@
 
   !********************
-  ! Verbosity, testing flags, namelist I/O
+  ! Verbosity, testing flags
   !********************   
   integer :: verbosity=0
   integer :: info_flag=0
-  integer :: count_clock, count_clock0,  count_rate, count_max
-  real    :: tins
-  logical :: nmlout=.true.
+  INTEGER :: count_clock, count_clock0,  count_rate, count_max
    
 
Index: /trunk/src/gridcheck.f90
===================================================================
--- /trunk/src/gridcheck.f90	(revision 30)
+++ /trunk/src/gridcheck.f90	(revision 20)
@@ -84,8 +84,8 @@
   real(kind=4) :: xaux1,xaux2,yaux1,yaux2
   real(kind=8) :: xaux1in,xaux2in,yaux1in,yaux2in
-  integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl,parID
+  integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl
   !HSO  end
   integer :: ix,jy,i,ifn,ifield,j,k,iumax,iwmax,numskip
-  real :: sizesouth,sizenorth,xauxa,pint,conversion_factor
+  real :: sizesouth,sizenorth,xauxa,pint
 
   ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING
@@ -98,5 +98,6 @@
 
   integer :: isec1(56),isec2(22+nxmax+nymax)
-  real(kind=4) :: zsec2(60+2*nuvzmax),zsec4(jpunp)
+  !real(kind=4) :: zsec2(60+2*nuvzmax),zsec4(jpunp)
+  real(kind=4) :: zsec2(184),zsec4(jpunp)
   character(len=1) :: opt
 
@@ -171,6 +172,4 @@
   call grib_check(iret,gribFunction,gribErrorMsg)
   call grib_get_int(igrib,'level',valSurf,iret)
-  call grib_check(iret,gribFunction,gribErrorMsg)
-  call grib_get_int(igrib,'paramId',parId,iret)
   call grib_check(iret,gribFunction,gribErrorMsg)
 
@@ -194,6 +193,4 @@
   elseif ((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
     isec1(6)=135         ! indicatorOfParameter
-  elseif ((parCat.eq.128).and.(parNum.eq.77)) then ! W, actually eta dot
-    isec1(6)=135         ! indicatorOfParameter
   elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101)) then !SLP
     isec1(6)=151         ! indicatorOfParameter
@@ -208,7 +205,7 @@
   elseif ((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SD
     isec1(6)=141         ! indicatorOfParameter
-  elseif ((parCat.eq.6).and.(parNum.eq.1) .or. parId .eq. 164) then ! CC
+  elseif ((parCat.eq.6).and.(parNum.eq.1)) then ! CC
     isec1(6)=164         ! indicatorOfParameter
-  elseif ((parCat.eq.1).and.(parNum.eq.9) .or. parId .eq. 142) then ! LSP
+  elseif ((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
     isec1(6)=142         ! indicatorOfParameter
   elseif ((parCat.eq.1).and.(parNum.eq.10)) then ! CP
@@ -218,11 +215,11 @@
   elseif ((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1)) then ! SR
     isec1(6)=176         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.17) .or. parId .eq. 180) then ! EWSS
+  elseif ((parCat.eq.2).and.(parNum.eq.17)) then ! EWSS
     isec1(6)=180         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.18) .or. parId .eq. 181) then ! NSSS
+  elseif ((parCat.eq.2).and.(parNum.eq.18)) then ! NSSS
     isec1(6)=181         ! indicatorOfParameter
   elseif ((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
     isec1(6)=129         ! indicatorOfParameter
-  elseif ((parCat.eq.3).and.(parNum.eq.7) .or. parId .eq. 160) then ! SDO
+  elseif ((parCat.eq.3).and.(parNum.eq.7)) then ! SDO
     isec1(6)=160         ! indicatorOfParameter
   elseif ((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and. &
@@ -233,8 +230,4 @@
          parCat,parNum,typSurf
   endif
-  if(parId .ne. isec1(6) .and. parId .ne. 77) then
-    write(*,*) 'parId',parId, 'isec1(6)',isec1(6)
-!    stop
-  endif
 
   endif
@@ -272,5 +265,5 @@
 
   !HSO  get the second part of the grid dimensions only from GRiB1 messages
-  if (isec1(6) .eq. 167 .and. (gotGrid.eq.0)) then
+  if ((gribVer.eq.1).and.(gotGrid.eq.0)) then
     call grib_get_real8(igrib,'longitudeOfLastGridPointInDegrees', &
          xaux2in,iret)
@@ -298,4 +291,5 @@
     dyconst=180./(dy*r_earth*pi)
     gotGrid=1
+
   ! Check whether fields are global
   ! If they contain the poles, specify polar stereographic map
@@ -443,11 +437,13 @@
   !********************
 
-  write(*,'(a,2i7)') ' Vertical levels in ECMWF data: ', &
+  write(*,*)
+  write(*,*)
+  write(*,'(a,2i7)') '# of vertical levels in ECMWF data: ', &
        nuvz+1,nwz
   write(*,*)
-  write(*,'(a)') ' Mother domain:'
-  write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Longitude range: ', &
+  write(*,'(a)') 'Mother domain:'
+  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ', &
        xlon0,' to ',xlon0+(nx-1)*dx,'   Grid distance: ',dx
-  write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Latitude range : ', &
+  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range: ', &
        ylat0,' to ',ylat0+(ny-1)*dy,'   Grid distance: ',dy
   write(*,*)
@@ -471,5 +467,4 @@
     k=nlev_ec+1+numskip+i
     akm(nwz-i+1)=zsec2(j)
-  !   write (*,*) 'ifield:',ifield,k,j,zsec2(10+j)
     bkm(nwz-i+1)=zsec2(k)
   end do
@@ -558,3 +553,2 @@
 
 end subroutine gridcheck
-
Index: /trunk/src/gridcheck_gfs.f90
===================================================================
--- /trunk/src/gridcheck_gfs.f90	(revision 30)
+++ /trunk/src/gridcheck_gfs.f90	(revision 20)
@@ -423,5 +423,5 @@
   write(*,*)
   write(*,*)
-  write(*,'(a,2i7)') 'Vertical levels in NCEP data: ', &
+  write(*,'(a,2i7)') '# of vertical levels in NCEP data: ', &
        nuvz,nwz
   write(*,*)
@@ -429,5 +429,5 @@
   write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ', &
        xlon0,' to ',xlon0+(nx-1)*dx,'   Grid distance: ',dx
-  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range : ', &
+  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range: ', &
        ylat0,' to ',ylat0+(ny-1)*dy,'   Grid distance: ',dy
   write(*,*)
Index: /trunk/src/gridcheck_nests.f90
===================================================================
--- /trunk/src/gridcheck_nests.f90	(revision 30)
+++ /trunk/src/gridcheck_nests.f90	(revision 20)
@@ -48,5 +48,4 @@
   integer :: igrib
   integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl
-  integer :: parID !added by mc for making it consistent with new gridcheck.f90
   integer :: gotGrib
   !HSO  end
@@ -56,5 +55,4 @@
   real(kind=4) :: xaux1,xaux2,yaux1,yaux2
   real(kind=8) :: xaux1in,xaux2in,yaux1in,yaux2in
-  real :: conversion_factor !added by mc to make it consistent with new gridchek.f90
 
   ! VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING
@@ -152,6 +150,4 @@
   call grib_get_int(igrib,'level',valSurf,iret)
   call grib_check(iret,gribFunction,gribErrorMsg)
-  call grib_get_int(igrib,'paramId',parId,iret) !added by mc to make it consisitent with new grid_check.f90
-  call grib_check(iret,gribFunction,gribErrorMsg) !added by mc to make it consisitent with new  grid_check.f90
 
   !print*,discipl,parCat,parNum,typSurf,valSurf
@@ -174,6 +170,4 @@
   elseif ((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
     isec1(6)=135         ! indicatorOfParameter
-  elseif ((parCat.eq.128).and.(parNum.eq.77)) then ! W, actually eta dot !added bymc to make it consistent with new gridchek.f90
-    isec1(6)=135         ! indicatorOfParameter    !                     ! " " " " " " " " " " " " " " " " " " " " " " " "  " " " 
   elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101)) then !SLP
     isec1(6)=151         ! indicatorOfParameter
@@ -188,7 +182,7 @@
   elseif ((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SD
     isec1(6)=141         ! indicatorOfParameter
-  elseif ((parCat.eq.6).and.(parNum.eq.1) .or. parId .eq. 164) then ! CC !added by mc to make it consistent with new gridchek.f90
+  elseif ((parCat.eq.6).and.(parNum.eq.1)) then ! CC
     isec1(6)=164         ! indicatorOfParameter
- elseif ((parCat.eq.1).and.(parNum.eq.9) .or. parId .eq. 142) then ! LSP !added by mc to make it consistent with new gridchek.f90
+  elseif ((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
     isec1(6)=142         ! indicatorOfParameter
   elseif ((parCat.eq.1).and.(parNum.eq.10)) then ! CP
@@ -198,11 +192,11 @@
   elseif ((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1)) then ! SR
     isec1(6)=176         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.17) .or. parId .eq. 180) then ! EWSS !added by mc to make it consistent with new gridchek.f90
+  elseif ((parCat.eq.2).and.(parNum.eq.17)) then ! EWSS
     isec1(6)=180         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.18) .or. parId .eq. 181) then ! NSSS !added by mc to make it consistent with new gridchek.f90
+  elseif ((parCat.eq.2).and.(parNum.eq.18)) then ! NSSS
     isec1(6)=181         ! indicatorOfParameter
   elseif ((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
     isec1(6)=129         ! indicatorOfParameter
-  elseif ((parCat.eq.3).and.(parNum.eq.7) .or. parId .eq. 160) then ! SDO !added by mc to make it consistent with new gridchek.f90
+  elseif ((parCat.eq.3).and.(parNum.eq.7)) then ! SDO
     isec1(6)=160         ! indicatorOfParameter
   elseif ((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and. &
@@ -213,8 +207,4 @@
          parCat,parNum,typSurf
   endif
-  if(parId .ne. isec1(6) .and. parId .ne. 77) then !added by mc to make it consistent with new gridchek.f90
-    write(*,*) 'parId',parId, 'isec1(6)',isec1(6)
-!    stop
-  endif
 
   endif
@@ -247,6 +237,6 @@
 
   !HSO  get the second part of the grid dimensions only from GRiB1 messages
-  if (isec1(6) .eq. 167 .and. (gotGrib.eq.0)) then !added by mc to make it consistent with new gridchek.f90 note that gotGrid must be changed in gotGrib!!
-    call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', & !comment by mc: note that this was in the (if (ifield.eq.1) ..end above in gridchek.f90 see line 257
+  if ((gribVer.eq.1).and.(gotGrib.eq.0)) then
+    call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', &
          xaux1in,iret)
     call grib_check(iret,gribFunction,gribErrorMsg)
@@ -264,14 +254,14 @@
     yaux1=yaux1in
     yaux2=yaux2in
-    if(xaux1.gt.180.) xaux1=xaux1-360.0
-    if(xaux2.gt.180.) xaux2=xaux2-360.0
-    if(xaux1.lt.-180.) xaux1=xaux1+360.0
-    if(xaux2.lt.-180.) xaux2=xaux2+360.0
-    if (xaux2.lt.xaux1) xaux2=xaux2+360.0
+    if(xaux1.gt.180) xaux1=xaux1-360.0
+    if(xaux2.gt.180) xaux2=xaux2-360.0
+    if(xaux1.lt.-180) xaux1=xaux1+360.0
+    if(xaux2.lt.-180) xaux2=xaux2+360.0
+    if (xaux2.lt.xaux1) xaux2=xaux2+360.
     xlon0n(l)=xaux1
     ylat0n(l)=yaux1
     dxn(l)=(xaux2-xaux1)/real(nxn(l)-1)
     dyn(l)=(yaux2-yaux1)/real(nyn(l)-1)
-    gotGrib=1 !commetn by mc note tahthere gotGRIB is used instead of gotGrid!!!
+    gotGrib=1
   endif ! ifield.eq.1
 
@@ -350,9 +340,9 @@
   !********************
 
-  write(*,'(a,i2,a)') ' Nested domain ',l,':'
-  write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Longitude range: ', &
+  write(*,'(a,i2)') 'Nested domain #: ',l
+  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ', &
        xlon0n(l),' to ',xlon0n(l)+(nxn(l)-1)*dxn(l), &
        '   Grid distance: ',dxn(l)
-  write(*,'(a,f10.5,a,f10.5,a,f10.5)') '  Latitude range : ', &
+  write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range: ', &
        ylat0n(l),' to ',ylat0n(l)+(nyn(l)-1)*dyn(l), &
        '   Grid distance: ',dyn(l)
Index: /trunk/src/interpol_rain.f90
===================================================================
--- /trunk/src/interpol_rain.f90	(revision 30)
+++ /trunk/src/interpol_rain.f90	(revision 20)
@@ -20,8 +20,15 @@
 !**********************************************************************
 
-subroutine interpol_rain(yy1,yy2,yy3,nxmax,nymax,nzmax,nx, &
-       ny,memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3)
-  !                          i   i   i    i    i     i   i
-  !i    i    i  i    i     i      i      i     o     o     o
+!subroutine interpol_rain(yy1,yy2,yy3,nxmax,nymax,nzmax,nx, &
+!       ny,memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3)
+!  !                          i   i   i    i    i     i   i
+!  !i    i    i  i    i     i      i      i     o     o     o
+
+      subroutine interpol_rain(yy1,yy2,yy3,iy1,iy2,nxmax,nymax,nzmax,nx, &
+     ny,memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3, &
+     intiy1,intiy2,icmv)
+!                               i   i   i    i    i     i   i 
+!     i    i    i  i    i     i      i      i     o     o     o
+
   !****************************************************************************
   !                                                                           *
@@ -40,5 +47,8 @@
   !                                                                           *
   !     30 August 1996                                                        *
-  !                                                                           *
+  !
+  !*  Petra Seibert, 2011/2012:
+  !*  Add interpolation of cloud bottom and cloud thickness
+  !*  for fix to SE's new wet scavenging scheme  *
   !****************************************************************************
   !                                                                           *
@@ -70,10 +80,15 @@
 
   integer :: nx,ny,nxmax,nymax,nzmax,memind(2),m,ix,jy,ixp,jyp
-  integer :: itime,itime1,itime2,level,indexh
+  !integer :: itime,itime1,itime2,level,indexh
+  integer :: itime,itime1,itime2,level,indexh,ip1,ip2,ip3,ip4 
+  integer :: intiy1,intiy2,ipsum,icmv  
   real :: yy1(0:nxmax-1,0:nymax-1,nzmax,2)
   real :: yy2(0:nxmax-1,0:nymax-1,nzmax,2)
   real :: yy3(0:nxmax-1,0:nymax-1,nzmax,2)
-  real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2)
-  real :: xt,yt,yint1,yint2,yint3,p1,p2,p3,p4
+  integer iy1(0:nxmax-1,0:nymax-1,2),iy2(0:nxmax-1,0:nymax-1,2)
+  real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2),yi1(2),yi2(2)
+  !real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2)
+  real :: xt,yt,yint1,yint2,yint3,yint4,p1,p2,p3,p4  
+  !real :: xt,yt,yint1,yint2,yint3,p1,p2,p3,p4
 
 
@@ -127,4 +142,43 @@
          + p3*yy3(ix ,jyp,level,indexh) &
          + p4*yy3(ixp,jyp,level,indexh)
+
+!CPS clouds:
+        ip1=1
+        ip2=1
+        ip3=1
+        ip4=1
+        if (iy1(ix ,jy ,indexh) .eq. icmv) ip1=0
+        if (iy1(ixp,jy ,indexh) .eq. icmv) ip2=0
+        if (iy1(ix ,jyp,indexh) .eq. icmv) ip3=0
+        if (iy1(ixp,jyp,indexh) .eq. icmv) ip4=0
+        ipsum= ip1+ip2+ip3+ip4
+        if (ipsum .eq. 0) then
+          yi1(m)=icmv
+        else
+          yi1(m)=(ip1*p1*iy1(ix ,jy ,indexh)    &
+             + ip2*p2*iy1(ixp,jy ,indexh)       &
+             + ip3*p3*iy1(ix ,jyp,indexh)       &
+             + ip4*p4*iy1(ixp,jyp,indexh))/ipsum
+        endif
+        
+        ip1=1
+        ip2=1
+        ip3=1
+        ip4=1
+        if (iy2(ix ,jy ,indexh) .eq. icmv) ip1=0
+        if (iy2(ixp,jy ,indexh) .eq. icmv) ip2=0
+        if (iy2(ix ,jyp,indexh) .eq. icmv) ip3=0
+        if (iy2(ixp,jyp,indexh) .eq. icmv) ip4=0
+        ipsum= ip1+ip2+ip3+ip4
+        if (ipsum .eq. 0) then
+          yi2(m)=icmv
+        else
+          yi2(m)=(ip1*p1*iy2(ix ,jy ,indexh)  &
+             + ip2*p2*iy2(ixp,jy ,indexh)     &
+             + ip3*p3*iy2(ix ,jyp,indexh)     &
+             + ip4*p4*iy2(ixp,jyp,indexh))/ipsum
+        endif
+!CPS end clouds
+
   end do
 
@@ -134,4 +188,11 @@
   !************************************
 
+      if (abs(itime) .lt. abs(itime1)) then
+        print*,'interpol_rain.f90'
+        print*,itime,itime1,itime2
+        stop 'ITIME PROBLEM'
+      endif
+
+
   dt1=real(itime-itime1)
   dt2=real(itime2-itime)
@@ -143,3 +204,20 @@
 
 
+!PS clouds:
+      intiy1=(yi1(1)*dt2 + yi1(2)*dt1)/dt
+      if (yi1(1) .eq. float(icmv)) intiy1=yi1(2) 
+      if (yi1(2) .eq. float(icmv)) intiy1=yi1(1) 
+
+      intiy2=(yi2(1)*dt2 + yi2(2)*dt1)/dt
+      if (yi2(1) .eq. float(icmv)) intiy2=yi2(2)  
+      if (yi2(2) .eq. float(icmv)) intiy2=yi2(1) 
+      
+      if (intiy1 .ne. icmv .and. intiy2 .ne. icmv) then
+        intiy2 = intiy1 + intiy2 ! convert cloud thickness to cloud top
+      else
+        intiy1=icmv
+        intiy2=icmv
+      endif
+!PS end clouds
+
 end subroutine interpol_rain
Index: /trunk/src/makefile
===================================================================
--- /trunk/src/makefile	(revision 30)
+++ /trunk/src/makefile	(revision 20)
@@ -1,11 +1,28 @@
 SHELL = /bin/bash
-MAIN = FP_ecmwf_gfortran
+TARGET = local
+WINDS=ecmwf
+#WINDS=gfs
+#WINDS=fnl
 
 FC       = gfortran
-INCPATH  = /xnilu_wrk/flex_wrk/bin64/grib_api/include
-LIBPATH1 = /xnilu_wrk/flex_wrk/bin64/grib_api/lib
-LIBPATH2 =   /usr/lib/x86_64-linux-gnu/
 FFLAGS   =   -O2 -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
-#FFLAGS   =   -fbounds-check -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+
+ifeq ($(TARGET),dmz)	
+  # options for ganglia
+  INCPATH  = /xnilu_wrk/flex_wrk/bin64/grib_api/include
+  LIBPATH1 = /xnilu_wrk/flex_wrk/bin64/grib_api/lib
+  LIBPATH2 = /usr/lib/x86_64-linux-gnu/
+  MAIN = FLEXPART_dmz_
+endif
+ifeq ($(TARGET),local)
+  # local options 	
+  #libs_dir=/.../flexpart/libs/
+  libs_dir=/Users/ignacio/flexpart/libs/
+  INCPATH  = $(libs_dir)/grib_api-1.9.9_dir/include
+  LIBPATH1 = $(libs_dir)/grib_api-1.9.9_dir/lib
+  LIBPATH2 = $(libs_dir)/jasper_dir/lib
+  MAIN = FLEXPART_local_
+endif
+
 LDFLAGS  = $(FFLAGS) -L$(LIBPATH2) -L$(LIBPATH1) -lgrib_api_f90 -lgrib_api -lm -ljasper
 
@@ -20,5 +37,5 @@
 OBJECTS = \
 writeheader.o  writeheader_txt.o   writeheader_surf.o       assignland.o\
-calcpar.o               part0.o \
+               part0.o \
 caldate.o               partdep.o \
 coordtrafo.o            psih.o \
@@ -36,26 +53,24 @@
 getrc.o                 readreleases.o \
 getvdep.o               readspecies.o \
-interpol_misslev.o      readwind.o \
-conccalc.o              richardson.o \
+interpol_misslev.o      \
+conccalc.o              \
 concoutput.o  concoutput_surf.o          scalev.o \
 pbl_profile.o           readOHfield.o\
 juldate.o               timemanager.o \
 interpol_vdep.o         interpol_rain.o \
-verttransform.o         partoutput.o \
+partoutput.o \
 hanna.o                 wetdepokernel.o \
 mean.o                  wetdepo.o \
 hanna_short.o           windalign.o \
-obukhov.o               gridcheck.o \
 hanna1.o                initialize.o \
-                        gridcheck_nests.o \
-readwind_nests.o        calcpar_nests.o \
+                           calcpar_nests.o \
 verttransform_nests.o   interpol_all_nests.o \
 interpol_wind_nests.o   interpol_misslev_nests.o \
 interpol_vdep_nests.o   interpol_rain_nests.o \
-getvdep_nests.o \
+getvdep_nests.o   gridcheck_nests.o \
+readwind_nests.o  \
 readageclasses.o        readpartpositions.o \
 calcfluxes.o            fluxoutput.o \
 qvsat.o                 skplin.o \
-convmix.o               calcmatrix.o \
 convect43c.o               redist.o \
 sort2.o                 distance.o \
@@ -76,6 +91,22 @@
 
 
-$(MAIN): $(MODOBJS) $(OBJECTS)
-	$(FC) *.o -o $(MAIN) $(LDFLAGS)
+ifeq ($(WINDS),ecmwf)
+  OBJECTS_WINDS = \
+  calcpar.o          readwind.o \
+  richardson.o       verttransform.o \
+  obukhov.o          gridcheck.o  \
+  convmix.o          calcmatrix.o 
+endif
+
+ifeq ($(WINDS),gfs)
+  OBJECTS_WINDS = \
+  calcpar_gfs.o          readwind_gfs.o \
+  richardson_gfs.o       verttransform_gfs.o \
+  obukhov_gfs.o          gridcheck_gfs.o  \
+  convmix_gfs.o          calcmatrix_gfs.o
+endif
+
+$(MAIN): $(MODOBJS) $(OBJECTS)  $(OBJECTS_WINDS)
+	$(FC) *.o -o $(MAIN)_$(WINDS) $(LDFLAGS)
 
 $(OBJECTS): $(MODOBJS)
@@ -87,4 +118,2 @@
 	rm *.o *.mod
 
-cleanall:
-	rm *.o *.mod $(MAIN)
Index: /trunk/src/outgrid_init.f90
===================================================================
--- /trunk/src/outgrid_init.f90	(revision 30)
+++ /trunk/src/outgrid_init.f90	(revision 20)
@@ -225,6 +225,6 @@
   !     maxspec,maxpointspec_act,nclassunc,maxageclass
 
-  write (*,*) 'Allocating fields for global output (x,y): ', numxgrid,numygrid
-  write (*,*) 'Allocating fields for nested output (x,y): ', numxgridn,numygridn 
+  write (*,*) ' Allocating fields for nested and global output (x,y): ', &
+       max(numxgrid,numxgridn),max(numygrid,numygridn) 
 
   ! allocate fields for concoutput with maximum dimension of outgrid
Index: /trunk/src/par_mod.f90
===================================================================
--- /trunk/src/par_mod.f90	(revision 30)
+++ /trunk/src/par_mod.f90	(revision 20)
@@ -121,7 +121,6 @@
   !*********************************************
   
-  !integer,parameter :: nxmax=361,nymax=181,nuvzmax=92,nwzmax=92,nzmax=92 !FNL XF
-  !integer,parameter :: nxmax=361,nymax=181,nuvzmax=152,nwzmax=152,nzmax=152 !ECMWF new 
-  integer,parameter :: nxmax=361,nymax=181,nuvzmax=92,nwzmax=92,nzmax=92 !ECMWF
+  integer,parameter :: nxmax=361,nymax=181,nuvzmax=92,nwzmax=92,nzmax=92 !FNL
+  !integer,parameter :: nxmax=361,nymax=181,nuvzmax=92,nwzmax=92,nzmax=92 !ECMWF
   !integer,parameter :: nxmax=361,nymax=181,nuvzmax=26,nwzmax=26,nzmax=26
   !integer,parameter :: nxmax=721,nymax=361,nuvzmax=64,nwzmax=64,nzmax=64
@@ -155,6 +154,6 @@
 
   !integer,parameter :: maxnests=0, nxmaxn=0, nymaxn=0
-  integer,parameter :: maxnests=1,nxmaxn=351,nymaxn=351 !ECMWF
-  !integer,parameter :: maxnests=1, nxmaxn=201, nymaxn=161 ! FNL XF
+  !integer,parameter :: maxnests=1,nxmaxn=251,nymaxn=151 !ECMWF
+  integer,parameter :: maxnests=1, nxmaxn=201, nymaxn=161 ! FNL XF
   ! maxnests                maximum number of nested grids
   ! nxmaxn,nymaxn           maximum dimension of nested wind fields in
@@ -198,6 +197,7 @@
   !**************************************************
 
-  integer,parameter :: maxpart=150000
-  integer,parameter :: maxspec=4
+  !integer,parameter :: maxpart=4000000
+  integer,parameter :: maxpart=2000
+  integer,parameter :: maxspec=6
 
 
Index: /trunk/src/readageclasses.f90
===================================================================
--- /trunk/src/readageclasses.f90	(revision 30)
+++ /trunk/src/readageclasses.f90	(revision 20)
@@ -28,7 +28,6 @@
   !                                                                            *
   !     Author: A. Stohl                                                       *
+  !                                                                            *
   !     20 March 2000                                                          *
-  !     HSO, 1 July 2014                                                       *
-  !     Added optional namelist input                                          *
   !                                                                            *
   !*****************************************************************************
@@ -47,13 +46,4 @@
   integer :: i
 
-  ! namelist help variables
-  integer :: readerror
-
-  ! namelist declaration
-  namelist /ageclass/ &
-    nageclass, &
-    lage
-
-  nageclass=-1 ! preset to negative value to identify failed namelist input
 
   ! If age spectra calculation is switched off, set number of age classes
@@ -67,33 +57,17 @@
   endif
 
+
   ! If age spectra claculation is switched on,
   ! open the AGECLASSSES file and read user options
   !************************************************
 
-  open(unitageclasses,file=path(1)(1:length(1))//'AGECLASSES',form='formatted',status='old',err=999)
+  open(unitageclasses,file=path(1)(1:length(1))//'AGECLASSES', &
+       status='old',err=999)
 
-  ! try to read in as a namelist
-  read(unitageclasses,ageclass,iostat=readerror)
-  close(unitageclasses)
+  do i=1,13
+    read(unitageclasses,*)
+  end do
+  read(unitageclasses,*) nageclass
 
-  if ((nageclass.lt.0).or.(readerror.ne.0)) then
-    open(unitageclasses,file=path(1)(1:length(1))//'AGECLASSES',status='old',err=999)
-    do i=1,13
-      read(unitageclasses,*)
-    end do
-    read(unitageclasses,*) nageclass
-    read(unitageclasses,*) lage(1)
-    do i=2,nageclass
-      read(unitageclasses,*) lage(i)
-    end do
-    close(unitageclasses)
-  endif
-
-  ! write ageclasses file in namelist format to output directory if requested
-  if (nmlout.eqv..true.) then
-    open(unitageclasses,file=path(2)(1:length(2))//'AGECLASSES.namelist',err=1000)
-    write(unitageclasses,nml=ageclass)
-    close(unitageclasses)
-  endif
 
   if (nageclass.gt.maxageclass) then
@@ -106,4 +80,5 @@
   endif
 
+  read(unitageclasses,*) lage(1)
   if (lage(1).le.0) then
     write(*,*) ' #### FLEXPART MODEL ERROR! AGE OF FIRST      #### '
@@ -114,4 +89,5 @@
 
   do i=2,nageclass
+    read(unitageclasses,*) lage(i)
     if (lage(i).le.lage(i-1)) then
       write(*,*) ' #### FLEXPART MODEL ERROR! AGE CLASSES     #### '
@@ -129,9 +105,3 @@
   stop
 
-1000  write(*,*) ' #### FLEXPART MODEL ERROR! FILE "AGECLASSES" #### '
-  write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
-  write(*,'(a)') path(2)(1:length(2))
-  stop
-
-
 end subroutine readageclasses
Index: /trunk/src/readavailable.f90
===================================================================
--- /trunk/src/readavailable.f90	(revision 30)
+++ /trunk/src/readavailable.f90	(revision 20)
@@ -123,6 +123,6 @@
 
   do k=1,numbnests
-  !print*,length(numpath+2*(k-1)+1),length(numpath+2*(k-1)+2),length(4),length(3)
-  !print*,path(numpath+2*(k-1)+2)(1:length(numpath+2*(k-1)+2))
+  print*,length(numpath+2*(k-1)+1),length(numpath+2*(k-1)+2),length(4),length(3)
+  print*,path(numpath+2*(k-1)+2)(1:length(numpath+2*(k-1)+2))
     open(unitavailab,file=path(numpath+2*(k-1)+2) &
          (1:length(numpath+2*(k-1)+2)),status='old',err=998)
